#ifndef BTL_SRIO_FIFO_H
#define BTL_SRIO_FIFO_H
///////////////////////////////////////////////////////////////////////////////////////////
int srio_type11_fifo_write(int dest_id, void *hdr1, int hdr1_len, void *hdr2, int hdr2_len, void *payload, int payload_len);

/*** Memory sync barrier ***/
static inline void btl_srio_atomic_dsb(void) {
  __asm__ __volatile__ ("dsb" : : : "memory");
}
static inline void btl_srio_atomic_dmb(void) {
  __asm__ __volatile__ ("dmb" : : : "memory");
}
/*** Time measurement functions ***/
static inline int64_t clock_diff_ns (struct timespec *start, struct timespec *end)
{
    return (end->tv_sec - start->tv_sec) * 1000000000 + end->tv_nsec - start->tv_nsec;
}
static inline uint32_t get_time_ns() {
   struct timespec time_now;
   clock_gettime(CLOCK_MONOTONIC, &time_now);
//   return ((uint64_t)time_now.tv_sec*1000000000  +  (uint64_t)time_now.tv_nsec);
   return time_now.tv_nsec;
}
extern uint32_t btl_srio_probe_point_trip_counter[], btl_srio_probe_point_start;
extern uint64_t btl_srio_probe_point_time[];
static inline void probe_pt_start (int tag_id)
{
   btl_srio_probe_point_start = get_time_ns();
}
static inline void probe_pt_end (int tag_id)
{
uint32_t tdiff = (uint32_t)(get_time_ns() - btl_srio_probe_point_start);
   btl_srio_probe_point_time[tag_id] += (uint64_t)tdiff;
   btl_srio_probe_point_trip_counter[tag_id] ++;
}

static inline void btl_srio_dump_buffer(char *ref_string, unsigned int *hdrc, int start_offset, int rows) {
  char dbg_out[256];
  int kk, l;
     kk = start_offset;
     for (l = 0; l < rows; l ++)
     {
       sprintf (dbg_out, "TIMPIDBG-%s-%4d [%08x %08x %08x %08x %08x %08x %08x %08x]", ref_string, kk,
                   hdrc[kk+0], hdrc[kk+1], hdrc[kk+2], hdrc[kk+3], hdrc[kk+4], hdrc[kk+5], hdrc[kk+6], hdrc[kk+7]);
       opal_output_verbose(20, mca_btl_base_output, "%s", dbg_out);
       kk += 8;
     }
}
#endif
/*** nothing past this point ***/
